"{ Package: 'jn:refactoring_custom' }"

CustomCodeGenerator subclass:#CustomAccessGeneratorClassCodeGenerator
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:''
!

!CustomAccessGeneratorClassCodeGenerator class methodsFor:'accessing-presentation'!

description
    ^  'l'

    "Modified: / 02-07-2014 / 18:15:12 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

label
    ^ 'AAA access generator'

    "Modified: / 02-07-2014 / 18:15:59 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomAccessGeneratorClassCodeGenerator class methodsFor:'queries'!

availableInContext:aCustomContext

    ^ aCustomContext selectedClasses notEmptyOrNil

    "Modified: / 02-07-2014 / 18:14:09 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

availableInPerspective:aCustomPerspective
    ^ true

    "Modified: / 02-07-2014 / 18:14:43 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomAccessGeneratorClassCodeGenerator methodsFor:'executing'!

executeInContext:aCustomContext
    | generatorClassName class |

    self startCollectChanges.       
    generatorClassName := dialog 
                            requestClassName: 'Enter class name for new generator' 
                            initialAnswer: 'CustomXAccessMethodsCodeGenerator'.

    class := builder createClass.
    class
        superclassName: 'CustomAccessMethodsCodeGenerator';
        className: generatorClassName;
        category: 'Interface-Refactoring-Custom'.

    builder
        class: class theMetaclass;
        protocol: 'accessing-presentation';
        source: ('description
    "Returns more detailed description of the receiver"

    ^ ''Access Method(s) XX for selected instance variables''
');
        createMethod;

        source: ('label
    "Returns show label describing the receiver. This label
     is used in UI as menu item/tree item label."

    ^ ''Access Method(s)''
');
        createMethod.

    self addBuilderChanges.

    self addChange: (InteractiveAddMethodChange compile:('buildInContext: aCustomContext
    "Creates access methods XX for given context"

    self
        executeSubGeneratorClasses: (
            Array
                with: CustomSimpleGetterMethodsCodeGenerator
                with: CustomSimpleSetterMethodsCodeGenerator
        ) 
        inContext: aCustomContext
    ') in:class asRBClass classified:'executing').

    self executeChangesInContext: aCustomContext changesName: ('Add ', self class description).

    "Created: / 03-07-2014 / 19:45:32 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
    "Modified: / 11-07-2014 / 23:09:22 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

