"{ Package: 'jn:refactoring_custom' }"

TestCase subclass:#CustomCodeGeneratorClassGeneratorTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Refactoring-Custom-Tests'
!


!CustomCodeGeneratorClassGeneratorTests methodsFor:'tests'!

test_code_generator_class_created

    | codeGenerator testClassName |

    testClassName := 'CustomCodeGeneratorForTestCase'.
    codeGenerator := CustomCodeGeneratorClassGenerator new.

    self assert: (Smalltalk classNamed: testClassName) isNil.

    codeGenerator buildForClassName: testClassName.
    codeGenerator builder compile.

    self assert: (Smalltalk classNamed: testClassName) isNil not.
    self assert: ((Smalltalk classNamed: testClassName) includesSelector: #buildInContext:).
    self assert: ((Smalltalk classNamed: testClassName) class includesSelector: #buildInContext:) not.
    self assert: ((Smalltalk classNamed: testClassName) includesSelector: #availableInContext:) not.
    self assert: ((Smalltalk classNamed: testClassName) class includesSelector: #availableInContext:).

    (Smalltalk classNamed: testClassName) removeFromSystem.

    "Created: / 31-03-2014 / 23:20:33 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
    "Modified: / 26-04-2014 / 00:24:55 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

test_code_generator_class_created_with_mock_dialog

    | codeGenerator testClassName mockDialog |

    testClassName := 'CustomCodeGeneratorForTestCase'.
    codeGenerator := CustomCodeGeneratorClassGenerator new.
    mockDialog := CustomSilentDialog new.
    mockDialog answer: testClassName forSelector: #requestClassName:initialAnswer:.
    codeGenerator dialog: mockDialog.  

    self assert: (Smalltalk classNamed: testClassName) isNil.

    codeGenerator executeInContext: (CustomSubContext new).  

    self assert: (Smalltalk classNamed: testClassName) isNil not.
    self assert: ((Smalltalk classNamed: testClassName) includesSelector: #buildInContext:).
    self assert: ((Smalltalk classNamed: testClassName) class includesSelector: #buildInContext:) not.
    self assert: ((Smalltalk classNamed: testClassName) includesSelector: #availableInContext:) not.
    self assert: ((Smalltalk classNamed: testClassName) class includesSelector: #availableInContext:).

    (Smalltalk classNamed: testClassName) removeFromSystem.

    "Created: / 11-05-2014 / 00:02:09 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
    "Modified: / 02-06-2014 / 22:10:37 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomCodeGeneratorClassGeneratorTests class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

