"{ Package: 'jn:refactoring_custom' }"

CustomCodeGeneratorTestCase subclass:#CustomCodeGeneratorTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Refactoring-Custom-Tests'
!

!CustomCodeGeneratorTests methodsFor:'accessing'!

generator
    ^ CustomCodeGenerator new
! !

!CustomCodeGeneratorTests methodsFor:'tests'!

test_execute_sub_generator_classes
    | subGeneratorClass_01 subGeneratorClass_02 expectedSource_01 expectedSource_02 |

    "/ setup context
    self classWithInstanceVariable.

    subGeneratorClass_01 := mock mockClassOf: CustomCodeGenerator.
    subGeneratorClass_02 := mock mockClassOf: CustomCodeGenerator.

    subGeneratorClass_01 mockSelector: #description withBlockValue: [ ^ '01' ].
    subGeneratorClass_01 new mockSelector: #buildInContext: withBlockValue: [
        :aCustomContext |

        aCustomContext selectedClasses do:[ :class | 
            builder
                source: 'selector_01 ^ 1';
                createMethod.
        ].
    ].

    subGeneratorClass_02 mockSelector: #description withBlockValue: [ ^ '02' ].
    subGeneratorClass_02 new mockSelector: #buildInContext: withBlockValue: [
        :aCustomContext |

        aCustomContext selectedClasses do:[ :class | 
            builder
                source: 'selector_02 ^ 2';
                createMethod.
        ].
    ].

    generator
        executeSubGeneratorClasses: (
            Array
                with: subGeneratorClass_01
                with: subGeneratorClass_02
        )
        inContext: context. 

    expectedSource_01 := 'selector_01
    ^ 1'.

    expectedSource_02 := 'selector_02
    ^ 2'.

    self assertMethodSource: expectedSource_01 atSelector: #selector_01.
    self assertMethodSource: expectedSource_02 atSelector: #selector_02.

    "Created: / 10-07-2014 / 12:11:40 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
    "Modified (format): / 11-07-2014 / 12:35:39 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

