"{ Package: 'jn:refactoring_custom' }"

CustomAccessMethodsCodeGenerator subclass:#CustomLazyInitializationGetterMethodsCodeGenerator
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Refactoring-Custom'
!

!CustomLazyInitializationGetterMethodsCodeGenerator class methodsFor:'accessing-presentation'!

description
    "Returns more detailed description of the receiver"

    ^ 'Getter methods with Lazy Initialization in Getter for selected instance variables'

    "Created: / 29-06-2014 / 19:12:18 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

label
    "Returns show label describing the receiver. This label
     is used in UI as menu item/tree item label."

    ^ 'Getter Method(s) with Lazy Initialization'

    "Created: / 29-06-2014 / 19:16:08 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
    "Modified: / 06-07-2014 / 23:14:30 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomLazyInitializationGetterMethodsCodeGenerator methodsFor:'code generation'!

sourceForClass: aClass variableName: aName
    "Returns getter with lazy initialization method source code for given class and variable name"

    | methodName comment methodBuilder |

    methodName := self methodNameFor: aName.
    comment := ''.

    userPreferences generateCommentsForGetters ifTrue:[
        | varType |

        varType := self varTypeOf: aName class: aClass. 
        comment := '"return the %1 instance variable ''%2'' with lazy instance creation (automatically generated)"'.
        comment := comment bindWith: varType with: aName.
    ].

    methodBuilder := builder methodBuilder.
    methodBuilder
        source: '`@methodName
            `"comment

            `variableName isNil ifTrue:[
                `variableName := self class `@defaultMethodName.
            ].
            ^ `variableName';
        replace: '`@methodName' with: methodName asSymbol;
        replace: '`@defaultMethodName' with: (self defaultMethodNameFor: aName) asSymbol;
        replace: '`variableName' with: aName asString;
        replace: '`"comment' with: comment.

    ^ methodBuilder buildedSource

    "Created: / 24-06-2014 / 23:24:41 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
    "Modified: / 29-06-2014 / 23:30:27 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomLazyInitializationGetterMethodsCodeGenerator methodsFor:'executing'!

buildInContext: aCustomContext
    | generator |

    generator := CustomDefaultGetterMethodsCodeGenerator subGeneratorOf: self.
    generator executeInContext: aCustomContext.

    super buildInContext: aCustomContext

    "Created: / 30-06-2014 / 18:00:47 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

