"{ Package: 'jn:refactoring_custom' }"

CustomChangeManager subclass:#CustomLocalChangeManager
	instanceVariableNames:'executedChanges'
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Refactoring-Custom'
!

!CustomLocalChangeManager class methodsFor:'documentation'!

documentation
"
    Unlike CustomBrowserChangeManager this implementation should not affect
    global Browser changes collector and Browser menus.

    [author:]
        Jakub Nesveda <nesvejak@fit.cvut.cz> 

"
! !

!CustomLocalChangeManager class methodsFor:'instance creation'!

new

    ^ self basicNew initialize

    "Created: / 31-05-2014 / 19:34:06 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomLocalChangeManager methodsFor:'initialization'!

initialize

    executedChanges := OrderedCollection new.

    "Created: / 31-05-2014 / 19:31:45 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomLocalChangeManager methodsFor:'performing-changes'!

performChange: aRefactoringChange

    executedChanges add: aRefactoringChange execute

    "Modified: / 31-05-2014 / 19:28:43 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

redoChanges
    "redo all changes made by performChange: method"

    executedChanges reversed do: [ :change | 
        change execute
    ].

    executedChanges removeAll

    "Created: / 31-05-2014 / 19:29:44 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
    "Modified: / 15-06-2014 / 17:02:42 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

