"{ Package: 'jn:refactoring_custom' }"

CustomAccessMethodsCodeGenerator subclass:#CustomValueHolderWithChangeNotificationSetterMethodsCodeGenerator
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Refactoring-Custom'
!

!CustomValueHolderWithChangeNotificationSetterMethodsCodeGenerator class methodsFor:'accessing-presentation'!

description
    "Returns more detailed description of the receiver"
    
    ^ 'Setter methods for ValueHolder with Change Notification for selected instance variables'

    "Modified: / 07-07-2014 / 00:02:57 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

label
    "Returns show label describing the receiver. This label
     is used in UI as menu item/tree item label."
    
    ^ 'Setter Method(s) for ValueHolder with Change Notification'

    "Modified: / 06-07-2014 / 23:59:37 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomValueHolderWithChangeNotificationSetterMethodsCodeGenerator methodsFor:'code generation'!

sourceForClass: aClass variableName: aName
    "Returns setter method for ValueHolder with change notification for given class and variable name"

    | methodName comment methodBuilder argName |

    methodName := self methodNameFor: aName.
    argName := self argNameForMethodName: methodName.  
    comment := ''.

    userPreferences generateCommentsForSetters ifTrue:[
        comment := '"set the ''%1'' value holder (automatically generated)"'.
        comment := comment bindWith: aName.
    ].

    methodBuilder := builder methodBuilder.
    methodBuilder
        source: '`@methodName
            `"comment

            | oldValue newValue |

            `variableName notNil ifTrue:[
                oldValue := `variableName value.
                `variableName removeDependent: self.
            ].
            `variableName := `argName.
            `variableName notNil ifTrue:[
                `variableName addDependent: self.
            ].
            newValue := `variableName value.
            oldValue ~~ newValue ifTrue:[
                self update:#value with:newValue from:`variableName.
            ].';
        replace: '`@methodName' with: (methodName, ': ', argName) asSymbol;
        replace: '`argName' with: argName asString;
        replace: '`variableName' with: aName asString;
        replace: '`"comment' with: comment.

    ^ methodBuilder buildedSource

    "Modified: / 06-07-2014 / 23:54:51 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

