"{ Package: 'jn:refactoring_custom' }"

LibraryDefinition subclass:#jn_refactoring_custom
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!jn_refactoring_custom class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

mandatoryPreRequisites
    "list packages which are mandatory as a prerequisite.
     This are packages containing superclasses of my classes and classes which
     are extended by myself.
     They are mandatory, because we need these packages as a prerequisite for loading and compiling.
     This method is generated automatically,
     by searching along the inheritance chain of all of my classes."

    ^ #(
        #'stx:goodies/refactoryBrowser/parser'    "RBProgramNodeVisitor - superclass of CustomSourceCodeBuilder "
        #'stx:goodies/sunit'    "TestAsserter - superclass of CustomAccessMethodsCodeGeneratorTests "
        #'stx:libbasic'    "LibraryDefinition - superclass of jn_refactoring_custom "
        #'stx:libtool'    "CodeGenerator - superclass of CustomSourceCodeBuilder "
        #'stx:libview2'    "ApplicationModel - extended "
    )
!

referencedPreRequisites
    "list packages which are a prerequisite, because they contain
     classes which are referenced by my classes.
     We do not need these packages as a prerequisite for loading or compiling.
     This method is generated automatically,
     by searching all classes (and their packages) which are referenced by my classes."

    ^ #(
        #'stx:goodies/refactoryBrowser/changes'    "CompositeRefactoryChange - referenced by CustomSourceCodeBuilder::Method>>createChange "
        #'stx:goodies/refactoryBrowser/helpers'    "RBClass - referenced by CustomCodeGeneratorOrRefactoring>>compile:forClass:inCategory:skipIfSame: "
        #'stx:libbasic3'    "Change - referenced by CustomCodeGeneratorTestCase>>assertSource:sameAs: "
        #'stx:libview'    "WindowGroup - referenced by CustomCodeGenerator>>executeInContext: "
    )
!

subProjects
    "list packages which are known as subprojects.
     The generated makefile will enter those and make there as well.
     However: they are not forced to be loaded when a package is loaded;
     for those, redefine requiredPrerequisites"

    ^ #(
    )
! !

!jn_refactoring_custom class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        CustomChangeManager
        CustomClassQuery
        (CustomClassQueryTests autoload)
        (CustomCodeGeneratorClassGeneratorTests autoload)
        CustomCodeGeneratorOrRefactoring
        (CustomCodeGeneratorTestCase autoload)
        CustomContext
        CustomDialog
        (CustomDummyTests autoload)
        CustomManager
        CustomMenuBuilder
        CustomMock
        (CustomMockTests autoload)
        CustomPerspective
        CustomSourceCodeBuilder
        (CustomSubclassResponsibilityCodeGeneratorTests autoload)
        (CustomVisitorCodeGeneratorAcceptVisitorTests autoload)
        (CustomVisitorCodeGeneratorTests autoload)
        TestClass
        #'jn_refactoring_custom'
        (CustomAccessMethodsCodeGeneratorTests autoload)
        CustomBrowserChangeManager
        CustomBrowserContext
        (CustomChangeNotificationAccessMethodsCodeGeneratorTests autoload)
        (CustomChangeNotificationSetterMethodsCodeGeneratorTests autoload)
        CustomCodeGenerator
        (CustomCodeGeneratorTests autoload)
        (CustomCodeGeneratorUserPreferencesTests autoload)
        (CustomDefaultGetterMethodsCodeGeneratorTests autoload)
        (CustomLazyInitializationAccessMethodsCodeGeneratorTests autoload)
        (CustomLazyInitializationGetterMethodsCodeGeneratorTests autoload)
        CustomLocalChangeManager
        CustomRefactoring
        CustomSilentDialog
        (CustomSimpleAccessMethodsCodeGeneratorTests autoload)
        (CustomSimpleGetterMethodsCodeGeneratorTests autoload)
        (CustomSimpleSetterMethodsCodeGeneratorTests autoload)
        (CustomSourceCodeBuilderTests autoload)
        CustomSubContext
        CustomUserDialog
        (CustomValueHolderAccessMethodsCodeGeneratorTests autoload)
        (CustomValueHolderGetterMethodsCodeGeneratorTests autoload)
        (CustomValueHolderWithChangeNotificationAccessMethodsCodeGeneratorTests autoload)
        (CustomValueHolderWithChangeNotificationGetterMethodsCodeGeneratorTests autoload)
        (CustomValueHolderWithChangeNotificationSetterMethodsCodeGeneratorTests autoload)
        CustomAccessGeneratorClassCodeGenerator
        CustomAccessMethodsCodeGenerator
        CustomAccessMethodsCodeGeneratorOld
        CustomCodeGeneratorClassGenerator
        CustomFooBarBazCodeGenerator
        CustomIsAbstractCodeGenerator
        CustomSubclassResponsibilityCodeGenerator
        CustomTestCaseCodeGenerator
        CustomVisitorCodeGenerator
        CustomChangeNotificationAccessMethodsCodeGenerator
        CustomChangeNotificationSetterMethodsCodeGenerator
        CustomCodeGeneratorTestCaseCodeGenerator
        CustomDefaultGetterMethodsCodeGenerator
        CustomLazyInitializationAccessMethodsCodeGenerator
        CustomLazyInitializationGetterMethodsCodeGenerator
        CustomSimpleAccessMethodsCodeGenerator
        CustomSimpleGetterMethodsCodeGenerator
        CustomSimpleSetterMethodsCodeGenerator
        CustomSimpleTestCaseCodeGenerator
        CustomValueHolderAccessMethodsCodeGenerator
        CustomValueHolderGetterMethodsCodeGenerator
        CustomValueHolderWithChangeNotificationAccessMethodsCodeGenerator
        CustomValueHolderWithChangeNotificationGetterMethodsCodeGenerator
        CustomValueHolderWithChangeNotificationSetterMethodsCodeGenerator
        CustomVisitorCodeGeneratorAcceptVisitor
    )
!

extensionMethodNames
    "list class/selector pairs of extensions.
     A correponding method with real names must be present in my concrete subclasses"

    ^ #(
        #'Tools::NewSystemBrowser' classMenuExtensionCustomRefactorings:
    )
! !

!jn_refactoring_custom class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'My Company'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Class Library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'My CopyRight or CopyLeft'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'ProductName'
! !

!jn_refactoring_custom class methodsFor:'documentation'!

version_HG
    ^ '$Changeset: <not expanded> $'
! !

